<?php
// 
// $Id: ezqdomrenderer.php,v 1.1 2001/04/09 12:37:40 bf Exp $
//
// Definition of eZQDomRenderer class
//
// Brd Farstad <bf@ez.no>
// Created on: <24-Mar-2001 12:54:26 bf>
//
// This source file is part of eZ publish, publishing software.
// Copyright (C) 1999-2001 eZ systems as
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, US
//

//!! eZArticle
//! eZTechRenderer renders XML contents into html articles.
/*!
  This class wil decode the tech articles generated by eZTechGenerator.
  Supported tags:
  \code
  <page> - pagebreak
  <header>
  Header text
  </header>
  <link ez.no text to the link> - anchor
  <iconlink ez.no text to the link> - anchor
  <mail adresse@domain.tld subject line, link text> - anchor to email address with subject
  <image 42 align size> - image tag, 42 is the id, alignment (left|center|right|float), size (small|medium|large|original)

  <ezanchor anchorname>

  <module modulename> - this will include a php file named "modulename.php" if it is found in the
  ezrticle/modules dir.

  <bullet>
  
  </bullet>

  <html>
  html code, this will print out the HTML code..
  </html>
  
  <cpp>
  cpp code
  </cpp>
  
  <php>
  php code
  </php>

  <java>
  java code
  </java>

  <ezhtml>
  html code
  </ezhtml>
  
  <shell>
  shell code
  </shell>
  
  <sql>
  sql code
  </sql>

  <perl>
  perl code
  </perl>

  <lisp>
  lisp code
  </lisp>
  
  <bold>
  bold text

  </bold>

  <italic>
  italic text
  </italic>

  <underline>
  underlined text
  </underline>

  <strike>
  strike text
  </strike>

  <pre>
  predefined text
  </pre>

  <verbatim>
  predefined text
  </verbatim>
  
  \endcode
  \sa eZTechGenerator  
*/

/*!TODO
  Add better syntax highlighting.

*/

include_once( "classes/eztexttool.php" );
include_once( "classes/ezlog.php" );

class eZQDomrenderer
{
    /*!
      Creates a new eZTechGenerator object.
    */
    function eZQDomrenderer( &$article )
    {
        $this->Article = $article;
    }

    /*!
      Returns the XHTML contents of the introduction of the article.
    */
    function &renderIntro()
    {
        $xml =& qdom_tree( $this->Article->contents() );

        if ( !$xml )
        {
            print( "<br /><b>Error: eZTechRenderer::docodeXML() could not decode XML</b><br />" );
        }
        else
        {
            $intro = "";
            $body = "";

            $articleImages = $this->Article->images();
            $articleID = $this->Article->id();

            $i=0;
            $this->$PrevTag = "";
            foreach ( $xml->children as $child )
            {
                if ( $child->name == "article" )
                {
                    foreach ( $child->children as $article )
                    {
                        if ( $article->name == "intro" )
                        {                           
                            if ( count( $article->children ) > 0 )
                            {
                                foreach ( $article->children as $paragraph )
                                {
                                    $intro = $this->renderPlain( $intro, $paragraph );
                                    $intro = $this->renderStandards( $intro, $paragraph );
                                    
//                                      $intro = $this->renderCode( $intro, $paragraph );
//                                      $intro = $this->renderLink( $intro, $paragraph );
//                                      $intro = $this->renderModule( $intro, $paragraph );
//                                      $intro = $this->renderImage( $intro, $paragraph, $articleImages );
                                    
                                    $this->PrevTag = $paragraph->name;
                                }
                            }
                        }
                    }
                }
            }
                
//            $newArticle = eZTextTool::nl2br( $intro );
                $newArticle = $intro;
        }
        
        return $newArticle;
    }

    /*!
      Returns the XHTML article of the article.
    */
    function &renderPage( $pageNumber=0 )
    {
        $xml =& qdom_tree( $this->Article->contents() );

//        $err = qdom_error();
//        if ( $err )
//            print( $err );
        
        if ( !$xml )
        {
            print( "<br /><b>Error: eZTechRenderer::docodeXML() could not decode XML</b><br />" );
        }
        else
        {
            $intro = "";
            $body = "";

            $this->$PrevTag = "";
            $articleImages =& $this->Article->images();
            $articleID = $this->Article->id();
            
            foreach ( $xml->children as $child )
            {
                if ( $child->name == "article" )
                {
                    foreach ( $child->children as $article )
                    {
                        if ( $article->name == "intro" )
                        {
                            if ( count( $article->children ) > 0 )
                                foreach ( $article->children as $paragraph )
                                {
                                    $intro .= $this->renderPlain( $paragraph );                                    
                                    $intro .= $this->renderStandards( $paragraph );
                                    
//                                    $intro = $this->renderCode( $intro, $paragraph );
//                                    $intro = $this->renderLink( $intro, $paragraph );
//                                    $intro = $this->renderModule( $intro, $paragraph );
//                                    $intro = $this->renderImage( $intro, $paragraph, $articleImages );
                                    
                                    $this->PrevTag = $paragraph->name;
                                }
                        }
                        
                        if ( $article->name == "body" )
                        {
                            $body = $article->children;
                        }                        
                    }
                }                
            }

            $pageArray = array();
            // loop on the pages
            foreach ( $body as $page )
            {
                $pageContent = "";
                $this->$PrevTag = "";
                // loop on the contents of the pages
                if ( count( $page->children ) > 0 )
                foreach ( $page->children as $paragraph )
                {
                    $pageContent .= $this->renderStandards( $paragraph );
                    $pageContent .= $this->renderPlain( $paragraph );
//                      $pageContent = $this->renderCode( $pageContent, $paragraph );
//                      $pageContent = $this->renderLink( $pageContent, $paragraph );
//                      $pageContent = $this->renderModule( $pageContent, $paragraph );
//                      $pageContent = $this->renderImage( $pageContent, $paragraph, $articleImages );

                    $this->PrevTag = $paragraph->name;
                }

                
                $pageArray[] = $pageContent;
                
            }

            if ( $pageNumber == -1 )
            {
                $newArticle = $intro . "\n</p><p>\n";
                if ( count( $pageArray ) > 0 )
                    foreach ( $pageArray as $page )
                    {
                        $newArticle .= $page;
                    }
            }
            else if ( $pageNumber != 0 )
            {
                $newArticle = $pageArray[$pageNumber];
            }
            else
            {
//                  $newArticle = eZTextTool::nl2br( $intro ) . "</p><p>". $pageArray[$pageNumber];
                $newArticle = $intro . "\n</p><p>\n". $pageArray[$pageNumber];
            }
                
        }
        
        return $newArticle;
    }

    function &renderPlain( $paragraph )
    {
        // ordinary text
        if ( $paragraph->name == "#text" || $paragraph->name == "text" )
        {
            $paragraph_text = $paragraph->content;
            if ( $paragraph_text[0] == "\n" )
            {
                if ( $this->PrevTag != "link" )
                    $paragraph_text[0] = " ";
            }
            $pageContent .= eZTextTool::nl2br( $paragraph_text );
        }
        return $pageContent;
    }


    function &renderStandards( $paragraph )
    {
        $pageContent = "";
        switch ( $paragraph->name )
        {
            case "bullet" :
            {
                $tmpContent = "";
                foreach ( $paragraph->children as $child )
                {
                    if ( $child->name == "#text" )
                    {
                        $content = $child->content;
                    }
                    else
                    {
                        $content = $this->renderStandards( $child );
                    }

                    $content = trim( $content );
                    $tmpContent .= preg_replace( "#^(.*)$#m", "<li>\\1</li>", $content );
                }
                
                $pageContent .= "<ul>" . $tmpContent . "</ul>";

            } break;

            case "bold" :
            {
                $tmpContent = "";
                foreach ( $paragraph->children as $child )
                {
                    if ( $child->name == "#text" )
                    {                
                        $tmpContent .= $child->content;
                    }
                    else
                    {
                        $tmpContent .= $this->renderStandards( $child );
                    }
                }
                $pageContent .= "<b>" . $tmpContent . "</b>";                
            }break;

            case "italic" :
            {
                $tmpContent = "";
                foreach ( $paragraph->children as $child )
                {
                    if ( $child->name == "#text" )
                    {                
                        $tmpContent .= $child->content;
                    }
                    else
                    {
                        $tmpContent .= $this->renderStandards( $child );
                    }
                }
                $pageContent .= "<i>" . $tmpContent . "</i>";
            }break;

            case "underline" :
            {
                $tmpContent = "";
                foreach ( $paragraph->children as $child )
                {
                    if ( $child->name == "#text" )
                    {                
                        $tmpContent .= $child->content;
                    }
                    else
                    {
                        $tmpContent .= $this->renderStandards( $child );
                    }
                }
                $pageContent .= "<u>" . $tmpContent . "</u>";
            }break;

        }
        
//          // header
//          if ( $paragraph->name == "header" )
//          {
//              $pageContent .= "\n<h2>".  $paragraph->children[0]->content . "</h2>\n";
//          }
                    
//          // bold text
//          if ( $paragraph->name == "bold" )
//          {
//              $pageContent .= "<b>" . $paragraph->children[0]->content . "</b>";
//          }

//          // italic text
//          if ( $paragraph->name == "italic" )
//          {
//              $pageContent .= "<i>" . $paragraph->children[0]->content . "</i>";
//          }

//          // underline text
//          if ( $paragraph->name == "underline" )
//          {
//              $pageContent .= "<u>" . $paragraph->children[0]->content . "</u>";
//          }

//          // strike text
//          if ( $paragraph->name == "strike" )
//          {
//              $pageContent .= "<s>" . $paragraph->children[0]->content . "</s>";
//          }

//          // pre text
//          if ( ( $paragraph->name == "pre" ) || ( $paragraph->name == "verbatim" ) )
//          {
//              $pageContent .= "<br clear=\"all\"><p><table width=\"100%\" cellspacing=\"0\" cellpadding=\"4\" border=\"0\"><tr><td bgcolor=\"#f0f0f0\"><pre>" .
//               $paragraph->children[0]->content . "</pre></td></tr></table></p>";
//          }

        
        return $pageContent;
    }    
    
    var $Article;
    var $PrevTag;
}

?>
