#
# Table structure for table 'eZBulkMail_Mail'
#
DROP TABLE IF EXISTS eZBulkMail_Mail;
CREATE TABLE eZBulkMail_Mail (
  ID int(11) DEFAULT '0' NOT NULL auto_increment,
  UserID int(11) default '0', 
  FromField varchar(100),
  FromName varchar(100),
  ReplyTo varchar(100),
  Subject varchar(255),
  BodyText text,
  SentDate timestamp(14) NOT NULL,
  IsDraft int(1) NOT NULL default '0',
  PRIMARY KEY (ID)
);

#
# Table structure for table 'eZBulkMail_Category'
#
DROP TABLE IF EXISTS eZBulkMail_Category;
CREATE TABLE eZBulkMail_Category (
  ID int(11) default '0' NOT NULL auto_increment,
  Name varchar(200) default NULL,
  IsPublic int(1) default '0',
  Description text,
  IsSingleCategory int(1) default '0',
  PRIMARY KEY (ID)
);

#
# Table structure for table 'eZBulkMail_GroupCategoryLink'
#

DROP TABLE IF EXISTS eZBulkMail_GroupCategoryLink;
CREATE TABLE eZBulkMail_GroupCategoryLink (
  CategoryID int(11) NOT NULL default '0',
  GroupID int(11) NOT NULL default '0',
  PRIMARY KEY (GroupID, CategoryID)
) TYPE=MyISAM;


#
# Table structure for table 'eZBulkMail_MailCategoryLink'
#

DROP TABLE IF EXISTS eZBulkMail_MailCategoryLink;
CREATE TABLE eZBulkMail_MailCategoryLink (
  MailID int(11) NOT NULL default '0',
  CategoryID int(11) NOT NULL default '0',
  PRIMARY KEY (MailID,CategoryID)
) TYPE=MyISAM;

#
# Table structure for table 'eZBulkMail_MailTemplateLink'
#

DROP TABLE IF EXISTS eZBulkMail_MailTemplateLink;
CREATE TABLE eZBulkMail_MailTemplateLink (
  MailID int(11) NOT NULL default '0',
  TemplateID int(11) NOT NULL default '0',
  PRIMARY KEY (MailID)
) TYPE=MyISAM;


#
# Table structure for table 'eZBulkMail_Template'
#

DROP TABLE IF EXISTS eZBulkMail_Template;
CREATE TABLE eZBulkMail_Template (
  ID int(11) default '0' NOT NULL auto_increment,
  Name varchar(200) default NULL,
  Description text,
  Header text,
  Footer text,
  PRIMARY KEY (ID)
) TYPE=MyISAM;

#
# Table structure for table 'eZBulkMail_SubscriptionLink'
#

DROP TABLE IF EXISTS eZBulkMail_SubscriptionLink;
CREATE TABLE eZBulkMail_SubscriptionLink (
  CategoryID int(11) NOT NULL default '0',
  AddressID int(11) NOT NULL default '0',
  PRIMARY KEY (AddressID,CategoryID)
) TYPE=MyISAM;

#
# Table structure for table 'eZBulkMail_SubscriptionAddress'
#

DROP TABLE IF EXISTS eZBulkMail_SubscriptionAddress;
CREATE TABLE eZBulkMail_SubscriptionAddress (
  ID int(11) default '0' NOT NULL auto_increment,
  EMail varchar(255),
  Password varchar(50) default '' NOT NULL,
  PRIMARY KEY (ID)
) TYPE=MyISAM;

#
# Table structure for table 'eZBulkMail_SentLog'
#

DROP TABLE IF EXISTS eZBulkMail_SentLog;
CREATE TABLE eZBulkMail_SentLog (
  ID int(11) default '0' NOT NULL auto_increment,
  MailID int(11) NOT NULL default '0',
  Mail varchar(255) NOT NULL default '0',  
  SentDate timestamp(14) NOT NULL,
  PRIMARY KEY (ID)
) TYPE=MyISAM;

#
# Table structure for table 'eZBulkMail_Forgot'
#
DROP TABLE IF EXISTS eZBulkMail_Forgot;
CREATE TABLE eZBulkMail_Forgot (
  ID int(11) DEFAULT '0' NOT NULL auto_increment,
  Mail varchar(255) DEFAULT '' NOT NULL,
  Password varchar(50) DEFAULT '' NOT NULL,
  Hash char(33),
  Time timestamp(14),
  PRIMARY KEY (ID)
);
