<?
include_once( "classes/INIFile.php" );
include_once( "classes/eztemplate.php" );
include_once( "classes/ezlocale.php" );
include_once( "ezuser/classes/ezuser.php" );
include_once( "classes/ezhttptool.php" );
include_once( "ezfilemanager/classes/ezvirtualfile.php" );
include_once( "ezmail/classes/ezmail.php" );

if( isset( $Cancel ) )
{
    if( $MailID != 0 )
    {
        $mail = new eZMail( $MailID );
        $folderID = $mail->folder( false );
    }
    else
    {
        $inbox = eZMailFolder::getSpecialFolder( INBOX );
        $folderID = $inbox->id();
    }
    eZHTTPTool::header( "Location: /mail/folder/$folderID" );
    exit();
}

if( isset( $AddAttachment ) )
{
    $MailID = save_mail();
    eZHTTPTool::header( "Location: /mail/fileedit/$MailID" );
    exit();
}

if( isset( $DeleteAttachments ) && count( $AttachmentArrayID ) > 0 )
{
    foreach( $AttachmentArrayID as $attachmmentID )
    {
        $mail = new eZMail( $MailID );
        $file = new eZVirtualFile( $attachmentID );
        $mail->deleteFile( $file );
    }
}

if( isset( $Preview ) )
{
}

if( isset( $Save ) )
{
    $MailID = save_mail();
    $mail = new eZMail( $MailID );
    $mail->setStatus( READ, true );

    $drafts = eZMailFolder::getSpecialFolder( DRAFTS );
    $drafts->addMail( $mail );
}

if( isset( $Send ) )
{
    $MailID = save_mail();
    // give error message if no valid users where supplied...
    $mail = new eZMail( $MailID );
    if( $mail->to() == "" && $mail->bcc() == "" && $mail->cc() == "" )
    {
        $error = "no_address";
    }
    else
    {
        $mail->setStatus( MAIL_SENT, true );
        $mail->send();

        $sent = eZMailFolder::getSpecialFolder( SENT );
        $sent->addMail( $mail );
    
        $sentid = $sent->id();
        eZHTTPTool::header( "Location: /mail/folder/$sentid" );
        exit();
    }
}

if( isset( $Cc ) )
    $showcc = true;
if( isset( $Bcc ) )
    $showbcc = true;

$ini =& INIFile::globalINI();
$Language = $ini->read_var( "eZMailMain", "Language" ); 

$t = new eZTemplate( "ezmail/user/" . $ini->read_var( "eZMailMain", "TemplateDir" ),
                     "ezmail/user/intl/", $Language, "mailedit.php" );

$languageIni = new INIFIle( "ezmail/user/intl/" . $Language . "/mailedit.php.ini", false );
$t->setAllStrings();

$t->set_file( array(
    "mail_edit_page_tpl" => "mailedit.tpl"
    ) );

$t->set_block( "mail_edit_page_tpl", "error_message_tpl", "error_message" );
$t->set_block( "mail_edit_page_tpl", "attachment_delete_tpl", "attachment_delete" );
$t->set_block( "mail_edit_page_tpl", "inserted_attachments_tpl", "inserted_attachments" );
$t->set_block( "mail_edit_page_tpl", "bcc_single_tpl", "bcc_single" );
$t->set_block( "mail_edit_page_tpl", "cc_single_tpl", "cc_single" );
$t->set_block( "inserted_attachments_tpl", "attachment_tpl", "attachment" );
$t->set_var( "inserted_attachments", "" );
$t->set_var( "attachment_delete", "" );

$t->set_var( "error_message", "" );
$t->set_var( "site_style", $SiteStyle );
$t->set_var( "to_value", "" );
$t->set_var( "from_value", "" );
$t->set_var( "cc_value", "" );
$t->set_var( "bcc_value", "" );
$t->set_var( "subject_value", "" );
$t->set_var( "mail_body", "" );
$t->set_var( "current_mail_id", "" );
$t->set_var( "cc_single", "" );
$t->set_var( "bcc_single", "" );

/** New mail, lets insert some default values **/
if( $MailID == 0 )
{
    // put signature stuff here...
}
$user = eZUser::currentUser();
$t->set_var( "from_value", $user->email() );

/** We are editing an allready existant mail... lets insert it's values **/
if( $MailID != 0 && eZMail::isOwner( eZUser::currentUser(), $MailID ) ) // load values from disk!, check that this is really current users mail
{
    $t->set_var( "current_mail_id", $MailID );
    
    $mail = new eZMail( $MailID );
    $t->set_var( "to_value", htmlspecialchars( $mail->to() ) );

    if( $mail->from() != "" )
        $t->set_var( "from_value", htmlspecialchars( $mail->from() ) );
    $t->set_var( "subject_value", htmlspecialchars( $mail->subject() ) );
    $t->set_var( "mail_body", htmlspecialchars( $mail->body() ) );
    
    if( $mail->cc() != ""  )
    {
        $showcc = true;
        $t->set_var( "cc_value", htmlspecialchars( $mail->cc() ) );
    }

    if( $mail->bcc() != "" )
    {
        $showbcc = true;
        $t->set_var( "bcc_value", htmlspecialchars( $mail->bcc() ) );
    }

    $files = $mail->files();
    $i = 0;
    foreach( $files as $file )
    {
        $t->set_var( "file_name", htmlspecialchars( $file->originalFileName() ) );
        $t->set_var( "file_id", $file->id() );

        $size = $file->siFileSize();
        $t->set_var( "file_size", $size["size-string"] . $size["unit"] );

        ( $i % 2 ) ? $t->set_var( "td_class", "bgdark" ) : $t->set_var( "td_class", "bglight" );
        
        $t->parse( "attachment", "attachment_tpl", true );
        $i++;
    }
    if( $i > 0 )
    {
        $t->parse( "attachment_delete", "attachment_delete_tpl" );
        $t->parse( "inserted_attachments", "inserted_attachments_tpl", false );
    }
}

// check if we have any errors... if yes. show them to the user
if( isset( $error ) )
{
    $t->set_var( "mail_error_message", $languageIni->read_var( "strings", "address_error" ) );
    $t->parse( "error_message", "error_message_tpl", true );
}

if( isset( $showcc ) )
        $t->parse( "cc_single", "cc_single_tpl", false );
if( isset( $showbcc ) )
        $t->parse( "bcc_single", "bcc_single_tpl", false );

$t->pparse( "output", "mail_edit_page_tpl" );

/*********************** FUNCTIONS ***************************************/

/*
  Saves the mail and returns the ID of the saved mail.
 */
function save_mail()
{
    global $To, $From, $Cc, $Bcc, $Subject, $MailBody, $MailID; // instead of passing them as arguments..

    if( $MailID == 0 )
    {
        $mail = new eZMail();
        $mail->setOwner( eZUser::currentUser() );
    }
    else
    {
        $mail = new eZMail( $MailID );
    }
    $mail->setTo( $To );
    $mail->setFrom( $From  ); // from NAME
    $mail->setCc( $Cc );
    $mail->setBcc( $Bcc );
//    $mail->setReferences( );
//    $mail->setReplyTo( $ );
    $mail->setSubject( $Subject );
    $mail->setBodyText( $MailBody );
    $mail->calculateSize();
    
    $mail->store();
    $folder = eZMailFolder::getSpecialFolder( DRAFTS );
    $folder->addMail( $mail );

    return $mail->id();
}

?>
